Given /^I have found an existing user$/ do
  @user = ActionKitApi::User.find_by_email('arealaddress@ipromise.com')
end

When /^I create a user with valid attributes$/ do
  @user = ActionKitApi::User.new({
      "email" => "arealaddress@ipromise.com",
      "first_name" => "Real",
      "last_name" => "Name",
      "zip" => "00001"
    })
end

When /^I save the user$/ do
  @user.save
end

When /^I create a user missing an email address$/ do
  @user = ActionKitApi::User.new({
      "first_name" => "Real",
      "last_name" => "Name",
      "zip" => "00001"
    })
end

When /^I change their zip code$/ do
  @new_zip = @user.zip.reverse
  @user.zip = @new_zip
end

When /^I search for a user that doesn't exist$/ do
  @user = ActionKitApi::User.find_by_email('thisisnteven@arealtld.lorp')
end

When /^I search a user that has already been created$/ do
  @user = ActionKitApi::User.find_by_email('arealaddress@ipromise.com')
end

Then /^I should receive a valid user$/ do
  @user.should be_valid
end

Then /^I should get an error when I save$/ do
  lambda{ @user.save }.should raise_error
end

Then /^the user should have an ActionKit ID$/ do
  @user.akid.should_not be_nil
end

Then /^I should receive nil$/ do
  @user.should be_nil
end

Then /^the user should have the new zip code$/ do
  @user.zip.should eql(@new_zip)
end
