require 'spec_helper'

module AKAPageSpecHelper
  def validPageAttributes
    {
      :name => "test_page",
      :title => "A Test Page",
    }
  end
end

describe ActionKitApi::PetitionPage do
  include AKAPageSpecHelper
  
  before(:each) do
    @page = ActionKitApi::PetitionPage.new
  end

  it "should have a type of 'petition'" do
    @page.type.should eql('petition')
  end

  it "should be valid with valid attributes" do
    @page.update(validPageAttributes)
    @page.should be_valid
  end

end

describe ActionKitApi::SignupPage do
  include AKAPageSpecHelper
  
  before(:each) do
    @page = ActionKitApi::SignupPage.new
  end

  it "should have a type of 'signup'" do
    @page.type.should eql('signup')
  end
  
  it "should be valid with valid attributes" do
    @page.update(validPageAttributes)
    @page.should be_valid
  end

end

describe ActionKitApi::UnsubscribePage do
  include AKAPageSpecHelper
  
  before(:each) do
    @page = ActionKitApi::UnsubscribePage.new
  end

  it "should have a type of 'unsubscribe'" do
    @page.type.should eql('unsubscribe')
  end
  
  it "should be valid with valid attributes" do
    @page.update(validPageAttributes)
    @page.should be_valid
  end

end

