require "spec_helper"

# These are tricky because they don't really verify much on our end and use
# command line utilities to do the verification, however if we aren't checking
# this if ActionKit changes their server certificate it will break our gem and
# need to be fixed by supplying new Certificate Authority information.

# These tests are not run by default. To run them add the --tag @certificates

describe "Remote API Server Certificate", :certificates => true do
  it "should be valid using system's certificates" do
    command_output = `echo "" | 
      openssl s_client -connect dfa.actionkit.com:443 2>&1 | 
      grep "Verify return code"`
    command_output =~ /[a-zA-Z]+: ([0-9]+)/
    $1.to_i.should == 0
  end

  it "should be valid using this gem's certificates" do
    command_output = `echo "" |
      openssl s_client -CAfile lib/action_kit_api/actionkit_ca_chain.pem -connect dfa.actionkit.com:443 2>&1 |
      grep "Verify return code"`
    command_output =~ /[a-zA-Z]+: ([0-9]+)/
    $1.to_i.should == 0
  end
end
